;-- TIME_STAMP   2021-01-19 17:33:22

#include <_XInput.au3>

Global $g_hUser32   = DllOpen("user32.dll")
Global $g_hWinmm    = DllOpen("winmm.dll")
Global $g_hKernel32 = DllOpen("kernel32.dll")

Global $iFire1 = 0, $iFire2 = 0, $iForward = 0, $iLeft = 0, $iRight = 0, $iBack = 0, $iToggle = 0, $iCrouch = 0, $iSensitivity = 4500 ; Higher Value equals less sensitive

_XInputInit()

OnAutoItExitRegister('_BF_Exit')

While 1
	$aInput = _XInputGetInput()
	$aButtons = _XInputButtons($aInput[2])

	_XInputVibrate(Round(($aInput[4] / 255) * 100), Round(($aInput[3] / 255) * 100))

	If $aButtons[14] Then Send("e")
	If $aButtons[10] Then MouseWheel("up")
	If $aButtons[9] Then MouseWheel("down")
	If $aButtons[11] Then Send("{SPACE}")
	If $aButtons[12] Then Send("r")
	If $aButtons[7] Then
		If $iToggle = 1 Then
			If $iCrouch = 1 Then
				Send("{CTRLUP}")
				$iCrouch = 0
			Else
				Send("{CTRLDOWN}")
				$iCrouch = 1
			EndIf
			$iToggle = 0
		EndIf
	Else
		$iToggle = 1
	EndIf
	If $aButtons[2] Then Send("z")

	If $aInput[4] < 200 And $iFire1 = 1 Then
		MouseUp("left")
		$iFire1 = 0
	ElseIf $iFire1 = 0 Then
		MouseDown("left")
		$iFire1 = 1
	EndIf

	If $aInput[3] < 200 And $iFire2 = 1 Then
		MouseUp("right")
		$iFire2 = 0
	Else
		If $iFire2 = 0 Then
			MouseDown("right")
			$iFire2 = 1
		EndIf
	EndIf

	If $aInput[6] < 22000 And $iForward = 1 Then
		Send("{w up}")
		$iForward = 0
	ElseIf $iForward = 0 Then
		Send("{w down}")
		$iForward = 1
	EndIf

	If $aInput[6] > -22000 And $iBack = 1 Then
		Send("{s up}")
		$iBack = 0
	ElseIf $iBack = 0 Then
		Send("{s down}")
		$iBack = 1
	EndIf

	If $aInput[5] < 22000 And $iLeft = 1 Then
		Send("{d up}")
		$iLeft = 0
	ElseIf $iLeft = 0 Then
		Send("{d down}")
		$iLeft = 1
	EndIf

	If $aInput[5] > -22000 And $iRight = 1 Then
		Send("{a up}")
		$iRight = 0
	ElseIf $iRight = 0 Then
		Send("{a down}")
		$iRight = 1
	EndIf

	If Abs($aInput[7]) > 4000 Or Abs($aInput[8]) > 4000 Then _
		_MouseMovePlus((($aButtons[8] * 2) + 1) * ($aInput[7] / $iSensitivity), -(($aButtons[8] * 2) + 1) * ($aInput[8] / $iSensitivity), $g_hUser32)

	_MySleep(5)
WEnd

Func _MySleep($t)
	DllCall($g_hWinmm, "long", "timeBeginPeriod", "long", 1)
	DllCall($g_hKernel32, "none", "Sleep", "long", $t)
	DllCall($g_hWinmm, "long", "timeEndPeriod", "long", 1)
EndFunc   ;==>_MySleep

Func _MouseMovePlus($X = "", $Y = "", $g_hUser32 = 0)
	Local $MOUSEEVENTF_MOVE = 0x1
	DllCall($g_hUser32, "none", "mouse_event", _
			"long", $MOUSEEVENTF_MOVE, _
			"long", $X, _
			"long", $Y, _
			"long", 0, _
			"long", 0)
EndFunc   ;==>_MouseMovePlus

Func _BF_Exit()
	DllClose($g_hUser32)
	DllClose($g_hWinmm)
	DllClose($g_hKernel32)
EndFunc
