;-- TIME_STAMP   2021-01-19 17:12:29

#include <_XInput.au3>

Example()

Func Example()
	_XInputInit()
	Local $sMessage = '', $sBtnText = '', $iSleep = 50, $aInput, $aButtons

	SplashTextOn("Xbox Controller Text", $sMessage, -1, -1, -1, -1, 4, "")
	While 1
		$sBtnText = ""
		$aInput = _XInputGetInput()
		$aButtons = _XInputButtons($aInput[2])
		_XInputVibrate(Round(($aInput[3] / 255) * 100), Round(($aInput[4] / 255) * 100))

		If $aButtons[ 1] Then $sBtnText &= "Up; " & @CRLF
		If $aButtons[ 2] Then $sBtnText &= "Down; " & @CRLF
		If $aButtons[ 3] Then $sBtnText &= "Left; " & @CRLF
		If $aButtons[ 4] Then $sBtnText &= "Right; " & @CRLF
		If $aButtons[ 5] Then $sBtnText &= "Start; " & @CRLF
		If $aButtons[ 6] Then $sBtnText &= "Back; " & @CRLF
		If $aButtons[ 7] Then $sBtnText &= "LJoy; " & @CRLF
		If $aButtons[ 8] Then $sBtnText &= "RJoy; " & @CRLF
		If $aButtons[ 9] Then $sBtnText &= "LButton; " & @CRLF
		If $aButtons[10] Then $sBtnText &= "RButton; " & @CRLF
		If $aButtons[11] Then $sBtnText &= "A; " & @CRLF
		If $aButtons[12] Then $sBtnText &= "B; " & @CRLF
		If $aButtons[13] Then $sBtnText &= "X; " & @CRLF
		If $aButtons[14] Then $sBtnText &= "Y; " & @CRLF
		$sBtnText = StringTrimRight($sBtnText, 2)

		$sMessage = _
			"-=Input=-" & @CRLF & _
			"Packet Number : " & $aInput[1] & @CRLF & _
			"Buttons       : " & $aInput[2] & @CRLF & _
			"Left Trigger  : " & $aInput[3] & @CRLF & _
			"Right Trigger : " & $aInput[4] & @CRLF & _
			"Left Joy X    : " & $aInput[5] & @CRLF & _
			"Left Joy Y    : " & $aInput[6] & @CRLF & _
			"Right Joy X   : " & $aInput[7] & @CRLF & _
			"Right Joy Y  : " & $aInput[8] & @CRLF & @CRLF & _
			"-=Buttons=-" & @CRLF & _
			$sBtnText
		ControlSetText("Xbox Controller Text", "", "Static1", $sMessage)
		Sleep($iSleep)
	WEnd
EndFunc

